<template>
  <div class="dashboard">
    <div class="container-fluid">
      <div id="menu-harmburger">
        <vs-button
          size="large"
          style="
            background: #ff9900;
            z-index: 300;
            border-bottom-right-radius: 25px;
            border-bottom-left-radius: 25px;
          "
          @click="toggleMenuBar"
        >
          <div id="menu-bar" class="button">
            <div class="bar top bg-white"></div>
            <div class="bar middle bg-white"></div>
            <div class="bar bottom bg-white"></div>
          </div>
        </vs-button>
      </div>
      <div class="row">
        <nav
          id="sidebarMenu"
          class="col-md-3 col-lg-2 d-md-block sidebar p-0"
          style="padding-bottom: 10px !important"
          @click="toggleMenu"
        >
          <div class="position-sticky side-nav-content pt-2 h-100">
            <div
              class="side-nav-menu nav-right visible-xs d-sm-block d-md-none"
            ></div>
            <div class="w-100 text-center mt-3">
              <img
                src="@/assets/img/logo.png"
                alt="Main Logo"
                style="height: 40px; text-align: center"
              />
            </div>

            <ul class="nav flex-column mt-5 side-links">
              <li class="nav-item" @click="toggleMenuBar">
                <nuxt-link to="/user/dashboard/overview" class="nav-link">
                  <DashboardIcon />
                  Dashboard
                </nuxt-link>
              </li>
              <li class="nav-item" @click="toggleMenuBar">
                <nuxt-link to="/user/dashboard/transfer" class="nav-link">
                  <Transfercon />
                  Transfer
                </nuxt-link>
              </li>
              <li class="nav-item" @click="toggleMenuBar">
                <nuxt-link to="/user/dashboard/airtime-data" class="nav-link">
                  <AirtimeDataIcon />
                  Airtime & Data
                </nuxt-link>
              </li>
              <li class="nav-item" @click="toggleMenuBar">
                <nuxt-link to="/user/dashboard/bill-payments" class="nav-link">
                  <BillPaymentsIcon />
                  Bill Payments
                </nuxt-link>
              </li>
              <!-- <li class="nav-item" @click="toggleMenuBar">
                <nuxt-link
                  to="/user/dashboard/cash-deposits"
                  class="nav-link text-truncate"
                >
                  <img src="@/assets/sidebaricons/cash.svg" alt="" />
                  Cash Deposits
                </nuxt-link>
              </li> -->
              <li class="nav-item" @click="toggleMenuBar">
                <a
                  href="/user/dashboard/investments"
                  class="nav-link text-truncate"
                >
                  <InvestmentsIcon />
                  Investments
                </a>
              </li>
              <li class="nav-item" @click="toggleMenuBar">
                <a
                  href="/user/dashboard/coming-soon"
                  class="nav-link text-truncate"
                >
                  <LoansIcon />
                  Loans
                </a>
              </li>
              <li class="nav-item" @click="toggleMenuBar">
                <nuxt-link
                  to="/user/dashboard/manage-cards/request-card"
                  class="nav-link text-truncate"
                >
                  <img src="@/assets/sidebaricons/managecards.svg" alt="" />
                  Manage Card
                </nuxt-link>
              </li>
              <li class="nav-item" @click="toggleMenuBar">
                <nuxt-link
                  to="/user/dashboard/transaction-history"
                  class="nav-link text-truncate"
                >
                  <img src="@/assets/sidebaricons/managecards.svg" alt="" />
                  Transaction History
                </nuxt-link>
              </li>
              <li class="nav-item" @click="toggleMenuBar">
                <nuxt-link
                  to="/user/dashboard/transaction-pin/set-security-questions"
                  class="nav-link text-truncate"
                >
                  <img src="@/assets/sidebaricons/managecards.svg" alt="" />
                  Set Transaction PIN
                </nuxt-link>
              </li>
              <li
                v-if="user.role === 'agent'"
                class="nav-item"
                @click="toggleMenuBar"
              >
                <nuxt-link
                  to="/user/dashboard/agency-banking"
                  class="nav-link text-truncate"
                >
                  <img src="@/assets/sidebaricons/managecards.svg" alt="" />
                  Agency Banking
                </nuxt-link>
              </li>
              <li v-else class="nav-item" @click="toggleMenuBar">
                <nuxt-link
                  to="/user/dashboard/agent-placeholder"
                  class="nav-link text-truncate"
                >
                  <img src="@/assets/sidebaricons/managecards.svg" alt="" />
                  Agency Banking
                </nuxt-link>
              </li>
              <li class="nav-item mt-2" @click="toggleMenuBar">
                <a href="#" class="nav-link" @click="logout">
                  <font-awesome-icon
                    class="sidebar-icon"
                    :icon="['fas', 'sign-out-alt']"
                  />

                  Logout
                </a>
              </li>
            </ul>
          </div>
        </nav>

        <main
          id="DashboardContent"
          class="col-md-9 ms-sm-auto col-lg-10 px-md-4"
        >
          <header
            id="mainNav"
            class="navbar navbar-dark sticky-top d-flex flex-nowrap p-0 shadow py-2 px-3 rounded-pill"
          >
            <input
              id="dashboard-search-navigation"
              type="text"
              class="px-3"
              placeholder="Search"
            />

            <ProfileBadge class="ms-2" />
          </header>
          <div class="pt-1">
            <Nuxt />
          </div>
        </main>
      </div>
    </div>
  </div>
</template>

<script>
// import DashboardIconActive from '@/assets/sidebaricons/dashboard-active.svg?inline'
import DashboardIcon from '@/assets/sidebaricons/dashboard.svg?inline'
import Transfercon from '@/assets/sidebaricons/transfer.svg?inline'
import AirtimeDataIcon from '@/assets/sidebaricons/airtime-data.svg?inline'
import BillPaymentsIcon from '@/assets/sidebaricons/bill-payment.svg?inline'
// import CashDepositsIcon from '@/assets/sidebaricons/cash.svg?inline'
import InvestmentsIcon from '@/assets/sidebaricons/investments.svg?inline'
import LoansIcon from '@/assets/sidebaricons/loans.svg?inline'
// import ManageCardsIcon from '@/assets/sidebaricons/managecards.svg?inline'
// import TransactionHistory from '@/assets/sidebaricons/transaction-history.svg?inline'

export default {
  components: {
    DashboardIcon,
    Transfercon,
    AirtimeDataIcon,
    BillPaymentsIcon,
    // CashDepositsIcon,
    // ManageCardsIcon,
    InvestmentsIcon,
    LoansIcon,
  },
  data: () => ({}),
  computed: {
    currentLink() {
      return this.$route.name
    },
    user() {
      return this.$store.getters['auth/user']
    },
  },
  created() {
    // setInterval(() => {
    //   this.refreshToken()
    // }, 2000)
  },
  mounted() {
    const MainNav = document.getElementById('mainNav')
    const MainProfileBadge = document.getElementById('main-profile-badge')

    window.onscroll = function () {
      if (document.scrollingElement.scrollTop >= 200) {
        MainNav.classList.add('bg-primary')
        MainProfileBadge.classList.add('swith-profile-badge-color')

        MainNav.classList.remove('bg-transparent')
        MainNav.classList.add('sticky-10')
      } else {
        MainNav.classList.add('bg-transparent')
        MainNav.classList.remove('bg-primary')
        MainNav.classList.remove('sticky-10')
        MainProfileBadge.classList.remove('swith-profile-badge-color')
      }
    }
  },
  methods: {
    logout() {
      localStorage.removeItem('core-bank-client-v1')
      this.$store.commit('auth/LOGOUT', '/')
    },
    toggleMenu() {},
    toggleClass(el, className) {
      el.classList.toggle(className)
    },
    toggleMenuBar() {
      this.toggleClass(document.querySelector('#menu-bar'), 'active')
      this.toggleClass(document.querySelector('main'), 'move-to-left')
      this.toggleClass(document.querySelector('header'), 'hide-header')
      this.toggleClass(document.querySelector('#sidebarMenu'), 'show-sidebar')
      this.toggleClass(
        document.querySelector('#DashboardContent'),
        'dashboard-contnent-d-none'
      )
    },
    async refreshToken() {
      try {
        const data = await this.$axios.$get('/auth/refresh-token')
        console.log(data)
      } catch (error) {
        console.log(error)
      }
    },
  },
}
</script>

<style lang="scss">
@import '~@/assets/scss/index';
@import '~@/assets/scss/variables';

.dashboard {
  background: #e8e1d4;
  min-height: 100vh;
}

#menu-harmburger {
  display: none;
  @include media-breakpoint-down(sm) {
    display: block;
  }
}

.dashboard-contnent-d-none {
  display: block;
  @include media-breakpoint-down(sm) {
    display: none;
  }
}

#mainNav {
  transition: all 0.2s ease-in;
}

.sticky-10 {
  top: 10px !important;
}

#dashboard-search-navigation {
  background: #ffffff;
  opacity: 0.4;
  border-radius: 15px;
  border: none;
  height: 47px;
  width: 75%;
}

.sidebar {
  position: fixed;
  top: 0;
  bottom: 0;
  left: 0;
  z-index: 100;

  will-change: height;
  // box-shadow: -7px 0 5px -6px rgba(0, 0, 0, 0.075);
  transition: all 0.25s ease;

  .side-nav-content {
    padding: 38px 0 0;
    background: #ffffff;
    border-radius: 20px;
    margin: 10px;
    margin-right: 0;
    margin-bottom: 40px;
  }

  &.hide-sidebar {
    transform: translate(-110%);
    // transform: translateX(100%);
  }
  &.show-sidebar {
    @include media-breakpoint-down(sm) {
      top: 0 !important;
      // transform: translate(-110%);
      transform: translate(0%);
    }
  }

  @include media-breakpoint-down(sm) {
    transform: translateX(100%);
  }
  .side-links {
    .nav-item {
      margin-bottom: 10px !important;
    }
    a.nav-link {
      color: #57666d;
      display: flex;
      align-items: center;
      padding-bottom: 10px;
      padding-top: 10px;
      padding-right: 5px;
      font-style: normal;
      font-weight: normal;
      font-size: 14px;
      line-height: 23px;
      transition: all 0.2s ease-in;
      margin-left: 25px;
      border-radius: 30px 0px 0px 30px;
      &.nuxt-link-active {
        // font-weight: bold;
        color: #000;
        background: #e8e1d4;
      }
      &:hover {
        // font-weight: bold;
        color: #000;
        background: #e8e1d4;
      }
      svg,
      img {
        margin-right: 20px;
      }
      &.nuxt-link-active {
        color: #000;
        background: #e8e1d4;
      }
    }
  }
  .side-nav-menu {
    position: absolute;
    right: 0;
  }
}

@media (max-width: 767.98px) {
  .sidebar {
    top: 5rem;
  }
}

.sidebar-sticky {
  position: relative;
  top: 0;
  height: calc(100vh - 48px);
  padding-top: 0.5rem;
  overflow-x: hidden;
  overflow-y: auto;

  @include media-breakpoint-down(sm) {
    height: 100vh;
  }
}

.sidebar-heading {
  font-size: 0.75rem;
  text-transform: uppercase;
}

#DashboardContent {
  // min-height: 100vh;
  header {
    // background: #ffffff;
    box-shadow: none !important;
    @include media-breakpoint-down(sm) {
      &.hide-header {
        display: none;
      }
    }
  }
  .page-title {
    font-style: normal;
    font-weight: bold;
    font-size: 18px;
    line-height: 48px;
    color: #4c5d5c;
  }
}
</style>

<style lang="scss" scoped>
@import '~@/assets/scss/index';
@import '~@/assets/scss/variables';
#DashboardContent {
  // background: $light !important;
  height: 100%;
  min-height: 100vh;
}

.button {
  cursor: pointer;
  display: inline-block;
  width: auto;
  margin: 0 auto;
  transition: all 0.7s ease;
}

.button.active .top {
  transform: translateY(15px) rotateZ(45deg);
}

.button.active .bottom {
  transform: translateY(-15px) rotateZ(-45deg);
}

.button.active .middle {
  width: 0;
}

.bar {
  display: block;
  height: 2px;
  width: 20px;
  background-color: #000;
  margin: 3px auto;
}

.bar {
  transition: all 0.7s ease;
}

.nav-right.visible-xs .active .bar {
  transition: all 0.7s ease;
}

.button.active .top {
  transform: translateY(5px) rotateZ(45deg);
}

.button.active .bottom {
  transform: translateY(-5px) rotateZ(-45deg);
}

.button.active .middle {
  width: 0;
}
</style>
